// $Id: quickfile-shared.js,v 1.9 2004/11/05 11:33:58 Paul Tomlin Exp $

function qfGetPrefs ()
{
	var prefs =
	{
		debug:
		{
			enable: false,
			copynotmove: false,
		},
		
		search:
		{
			root: 'msgaccounts:/',
			casesensitive: false,
			expandspaces: true
		},
		
		defaultfolder:
		{
			enable: false,
			folder: ''
		},
		
		shortcut:
		{
			key: 'q',
			modifiers: 'alt'
		},
		
		autoselectnext: false
	};

	// just get a handle on our part os the preferences, to be safe
	var prefsService = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch('quickfile.');

	try
	{
		prefs.debug.enable         = prefsService.getBoolPref('debug.enable');
		prefs.debug.copynotmove    = prefsService.getBoolPref('debug.copynotmove');

		prefs.search.root          = prefsService.getCharPref('search.root');
		prefs.search.casesensitive = prefsService.getBoolPref('search.casesensitive');
		prefs.search.expandspaces  = prefsService.getBoolPref('search.expandspaces');
		
		prefs.defaultfolder.enable = prefsService.getBoolPref('defaultfolder.enable');
		prefs.defaultfolder.folder = prefsService.getCharPref('defaultfolder.folder');
		
		prefs.shortcut.key		   = prefsService.getCharPref('shortcut.key');
		prefs.shortcut.modifiers   = prefsService.getCharPref('shortcut.modifiers');
		
		prefs.autoselectnext	   = prefsService.getBoolPref('autoselectnext');
	}
	catch (e)
	{ /* ignored */ }
	
	return prefs;
};

function qfSetPrefs (prefs)
{
	// just get a handle on our part os the preferences, to be safe
	var prefsService = Components.classes["@mozilla.org/preferences-service;1"]
						.getService(Components.interfaces.nsIPrefService)
						.getBranch('quickfile.');
	
	prefsService.setBoolPref('debug.enable',         prefs.debug.enable);
	prefsService.setBoolPref('debug.copynotmove',    prefs.debug.copynotmove);
	
	prefsService.setCharPref('search.root',          prefs.search.root);
	prefsService.setBoolPref('search.casesensitive', prefs.search.casesensitive);
	prefsService.setBoolPref('search.expandspaces',  prefs.search.expandspaces);
	
	prefsService.setBoolPref('defaultfolder.enable', prefs.defaultfolder.enable);
	prefsService.setCharPref('defaultfolder.folder', prefs.defaultfolder.folder);
	
	prefsService.setCharPref('shortcut.key', 		 prefs.shortcut.key);
	prefsService.setCharPref('shortcut.modifiers', 	 prefs.shortcut.modifiers);
	
	prefsService.setBoolPref('autoselectnext', 	 	 prefs.autoselectnext);
};

function qfGetFolderFromMessageURI (messageURI)
{
	var folder = null;
	
	try
	{
		// get a handle on a messenger instance
		var messenger = Components.classes['@mozilla.org/messenger;1']
							.createInstance(Components.interfaces.nsIMessenger);

		// what service deals with this message type					
		var messageService = messenger.messageServiceFromURI(messageURI)

		// the message header
		var hdr = messageService.messageURIToMsgHdr(messageURI)

		// what folder is the message in
		folder = hdr.folder;
	}
	catch (e)
	{
		// 
		alert(e);
	}

	return folder;
};

function qfGetFolderFromFolderURI (folderURI)
{
	var folder = null;
	
	// RDF service
	var rdfService = Components.classes['@mozilla.org/rdf/rdf-service;1']
						.getService(Components.interfaces.nsIRDFService);

	try
	{
		folder = rdfService.GetResource(folderURI)
					.QueryInterface(Components.interfaces.nsIMsgFolder);
	}
	catch (e)
	{
		// reset
		folder = null;
	}
	
	return folder;
}

//
// qfSetShortcut
// Sets the shortcut used by quickfile-overlay 
function qfSetShortcut(key, modifiers)
{
	
};

function qfGetNameFromFolderURI(folderURI)
{
	var folderName = '';
	
	try
	{
		var rdfService = Components.classes['@mozilla.org/rdf/rdf-service;1']
							.getService(Components.interfaces.nsIRDFService);

		var folder = rdfService.GetResource(folderURI)
							.QueryInterface(Components.interfaces.nsIMsgFolder);

		do
		{
			// get this folders' name
			folderName = folder.name + '/' + folderName;

			// go up one level
			folder = folder.parentMsgFolder;
		}
		while (folder)
	}
	catch (e)
	{
		/* ignore this */
	}
	
	// TODO: do we need to trim off the trailing /
	//  it appears not, but I'll leave this here in case it causes an issue
	// as of 0.11 the default folder feature seems to break if we leave
	//  the trailing /, so kill it if it's there
	folderName = folderName.replace(/\/$/, '');
	
	return folderName;
};

function qfDump(str)
{
	var csClass = Components.classes['@mozilla.org/consoleservice;1'];
	var cs = csClass.getService(Components.interfaces.nsIConsoleService);
	
	cs.logStringMessage(str);

	dump(str + "\n");
};
